%define subrel	2

%define privoxyconf %{_sysconfdir}/%{name}

%define reltype stable

Summary:	Privacy enhancing HTTP proxy
Name:		privoxy
Version:	3.0.21
Release:	%mkrel 2
License:	GPLv2+
Group:		Networking/Other
URL:		http://www.privoxy.org/
Source0:	http://prdownloads.sf.net/ijbswa/%{name}-%{version}-%{reltype}-src.tar.gz
Source1:	http://prdownloads.sf.net/ijbswa/%{name}-%{version}-%{reltype}-src.tar.gz.asc
Source2:	privoxy.logrotate
Source4:	%{name}.service
Patch0:		privoxy-3.0.21-mga-mdv-missing-user.filter.patch
Patch1:		privoxy-3.0.21-cid-66368.patch
Patch2:		privoxy-3.0.21-cid-66382.patch
Patch3:		privoxy-3.0.21-cid-66394.patch
Patch4:		privoxy-3.0.21-cid-66376-66391.patch
Requires(post): rpm-helper
Requires(preun): rpm-helper
Obsoletes:	junkbuster
Provides:	junkbuster = %{version}-%{release}
Provides:	webproxy
BuildRequires:	docbook-style-dsssl
BuildRequires:	docbook-dtd42-xml
BuildRequires:	docbook-dtd31-sgml
BuildRequires:	lynx
BuildRequires:	man
BuildRequires:	pcreposix-devel
BuildRequires:	zlib-devel

%description
Privoxy is a web proxy with advanced filtering capabilities for protecting
privacy, filtering web page content, managing cookies, controlling access, and
removing ads, banners, pop-ups and other obnoxious Internet Junk. Privoxy has a
very flexible configuration and can be customized to suit individual needs and
tastes. Privoxy has application for both stand-alone systems and multi-user
networks.

Privoxy was previously called Internet Junkbuster.

To configure privoxy, go to http://config.privoxy.org/

Privoxy proxy is running on port 8118

%prep

%setup -n %{name}-%{version}-%{reltype} -q

# manpage should be in section 8
sed -i -e 's/^\(\.TH "PRIVOXY" \)"1"/\1"8"/g' privoxy.1 

# privoxy.missing.user.filter.patch
%patch0 -p1
%patch1 -p0 -b .cid66368
%patch2 -p0 -b .cid66382
%patch3 -p0 -b .cid66394
%patch4 -p0 -b .cid66376-66391

%build
#needed for build
autoreconf

%serverbuild
%configure2_5x --with-user=daemon --with-group=daemon
%make

%install
mkdir -p %{buildroot}%{_sbindir} \
         %{buildroot}%{_mandir}/man8 \
         %{buildroot}/var/log/privoxy \
         %{buildroot}%{privoxyconf}/templates \
         %{buildroot}%{_sysconfdir}/logrotate.d

install -m 755 privoxy %{buildroot}%{_sbindir}/privoxy
install -m 644 privoxy.1 %{buildroot}%{_mandir}/man8/privoxy.8

# Install various config files
for i in *.action default.filter trust; do
	install -m 644 $i %{buildroot}%{privoxyconf}/
done
for i in templates/*; do
	install -m 644 $i %{buildroot}%{privoxyconf}/templates/
done
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
install -d -m 755 %{buildroot}%{_unitdir}
install -m 644 %{SOURCE4} %{buildroot}%{_unitdir}/%{name}.service

# verify all file locations, etc. in the config file
# don't start with ^ or commented lines are not replaced
sed -e 's!^confdir.*!confdir /etc/privoxy!g' \
    -e 's!^logdir.*!logdir /var/log/privoxy!g' \
    < config  > %{buildroot}%{privoxyconf}/config

#remove backup files
rm -f doc/privoxy/webserver/user-manual/*.bak

# create compatibility symlink
ln -s match-all.action %{buildroot}/%{privoxyconf}/standard.action

%triggerin -- msec < 0.17
for i in 0 1 2 3 4 5; do
  permfile="%{_sysconfdir}/security/msec/perm.$i"
  if grep -q '^/var/log/privoxy' $permfile; then
    perl -pi -e 's|^/var/log/privoxy\s.*|/var/log/prixovy\t\t\t\tdaemon.daemon\t700|' $permfile
  else
    echo -e "/var/log/prixovy\t\t\t\tdaemon.daemon\t700" >> $permfile
  fi
done


%post
%_post_service privoxy

%preun
%_preun_service privoxy

%files
%doc AUTHORS ChangeLog README  
%doc doc/webserver
%attr (0700,daemon,daemon) /var/log/privoxy
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{_sbindir}/*
%{_mandir}/man8/*

%defattr(664,daemon,daemon,755)
%dir %{privoxyconf}
%config(noreplace) %{privoxyconf}/config
%config            %{privoxyconf}/default.action
%config(noreplace) %{privoxyconf}/default.filter
%config(noreplace) %{privoxyconf}/templates
%config(noreplace) %{privoxyconf}/match-all.action
%config(noreplace) %{privoxyconf}/trust
%config(noreplace) %{privoxyconf}/user.action
%config(noreplace) %{privoxyconf}/regression-tests.action
%{privoxyconf}/standard.action
%{_unitdir}/%{name}.service


%changelog
* Sun Dec 28 2014 cjw <cjw> 3.0.21-2.2.mga4
+ Revision: 806999
- patch1: fix a file descriptor leak in an error path (CID 66368)
- patch2: fix a memory leak (CID 66382)
- patch3: fix a use-after-free bug (CID 66394)
- patch4: fix potential use-after-free situations (CID 66376, CID 66391)
- restart the daemon on logrotate so it uses the new logfile (fixes mga #13785)

* Sat Oct 19 2013 umeabot <umeabot> 3.0.21-2.mga4
+ Revision: 522506
- Mageia 4 Mass Rebuild

* Tue Mar 12 2013 solbu <solbu> 3.0.21-1.mga3
+ Revision: 402171
- New version
- Rediff patch, and rename according to policy

* Fri Feb 08 2013 solbu <solbu> 3.0.19-4.mga3
+ Revision: 395301
- systemd integration
- Kill init script
- Fix License tag

* Sun Jan 13 2013 umeabot <umeabot> 3.0.19-3.mga3
+ Revision: 378216
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Dec 01 2012 fwang <fwang> 3.0.19-2.mga3
+ Revision: 323740
- br pcreposix

* Wed Mar 07 2012 boklm <boklm> 3.0.19-1.mga2
+ Revision: 221204
- Version 3.0.19

* Wed Nov 23 2011 fwang <fwang> 3.0.18-1.mga2
+ Revision: 171273
- new version 3.0.18

* Wed Sep 07 2011 tv <tv> 3.0.17-1.mga2
+ Revision: 140084
- fix missing LSB keywords
- new release
- BR zlib
- patch : missing user.filter file (mdv#63573)

* Sun Mar 06 2011 ennael <ennael> 3.0.16-2.mga1
+ Revision: 65639
- imported package privoxy

